'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _mapValues2 = require('lodash/mapValues');

var _mapValues3 = _interopRequireDefault(_mapValues2);

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (actionsToBind, dispatch) {

	var bind = function bind(actionCreator) {
		return function () {
			var action = actionCreator.apply(undefined, arguments);

			if (action.__request) {
				return new Promise(function (resolve, reject) {
					return dispatch(_extends({}, action, {
						__request: _extends({}, action.__request, {
							resolve: resolve,
							reject: reject
						})
					}));
				});
			}

			return dispatch(action);
		};
	};

	if (typeof actionsToBind === 'function') {
		return bind(actionsToBind);
	}

	if ((typeof actionsToBind === 'undefined' ? 'undefined' : _typeof(actionsToBind)) === 'object') {
		return (0, _mapValues3.default)(actionsToBind, bind);
	}

	throw new Error('bindAndTrace() expected an object or a function, instead received ' + actionsToBind);
};