'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _remove2 = require('lodash/remove');

var _remove3 = _interopRequireDefault(_remove2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (socket) {
	return function (store) {

		var requests = [];

		var emit = function emit(action) {
			return socket.emit(_constants.SOCKET_EVENT, action);
		};

		socket.on("connect", function () {
			return store.dispatch({ type: _constants.SOCKET_CONNECTED });
		});
		socket.on("disconnect", function () {
			return store.dispatch({ type: _constants.SOCKET_DISCONNECTED });
		});

		socket.on(_constants.SOCKET_EVENT, function (serverAction) {
			var __request = serverAction.__request;


			if (__request) {
				var clientAction = (0, _remove3.default)(requests, function (action) {
					return action.__request.id == __request.id;
				})[0];

				if (clientAction) {
					var _dispatch = function _dispatch(promiseHandle) {
						if (promiseHandle) {
							promiseHandle(serverAction, store);
						}

						store.dispatch(_extends({}, serverAction, {
							type: __request.status
						}));

						serverAction.RESPONSE_ACTION = true;
					};

					if (__request.status == _constants.COMPLETE_REQUEST) _dispatch(clientAction.__request.resolve);
					if (__request.status == _constants.FAIL_REQUEST) _dispatch(clientAction.__request.reject);
				}
			}

			if (serverAction.type) {
				store.dispatch(serverAction);
			}
		});

		return function (next) {
			return function (action) {
				if (action.REQUEST_ACTION) {

					/* Dispatch a BEGIN_REQUEST action containing the
      * action requestId, requestName and any additional
      * properties provided by the user.
      * */
					store.dispatch(_extends({}, action, {
						REQUEST_ACTION: false,
						type: _constants.BEGIN_REQUEST
					}));

					/* Add the action to state and emit the
      * action through the socket.
      * */
					requests.push(action);
					emit(action);
				}

				return next(action);
			};
		};
	};
};