'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _constants = require('../constants');

exports.default = function (socket, handler) {
	return socket.on(_constants.SOCKET_EVENT, function (action) {
		var emit = function emit(action) {
			return socket.emit(_constants.SOCKET_EVENT, action);
		};

		var resolved = false;
		var resolve = function resolve(responseAction) {
			if (resolved) {
				if (!responseAction) return;
				return emit(responseAction);
			}

			resolved = true;
			if (responseAction) {
				return emit(_extends({
					type: _constants.REQUEST_RESPONSE
				}, responseAction || {}, {

					__request: _extends({}, action.__request, {
						status: _constants.COMPLETE_REQUEST
					})
				}));
			}

			emit({
				type: _constants.REQUEST_RESPONSE,

				__request: _extends({}, action.__request, {
					status: _constants.COMPLETE_REQUEST
				})
			});
		};

		var rejected = false;
		var reject = function reject(rejectAction) {
			if (rejected) {
				return console.log("Cannot call reject more than once");
			}

			var resultingAction = {
				type: _constants.REQUEST_RESPONSE,
				payload: rejectAction
			};

			if (rejectAction && (typeof rejectAction === 'undefined' ? 'undefined' : _typeof(rejectAction)) === 'object' && rejectAction.type) {
				resultingAction = rejectAction;
			}

			rejected = true;
			emit(_extends({}, resultingAction, {

				__request: _extends({}, action.__request, {
					status: _constants.FAIL_REQUEST
				})
			}));
		};

		return handler({
			socket: socket,
			action: action,
			resolve: resolve,
			reject: reject
		});
	});
};