import io from 'socket.io-client'
import { createStore, applyMiddleware, compose } from 'redux'
import { clientMiddleware, requestReducer, requestAction, bindAndTrace } from '../src'

const socket = io("http://localhost:2001")

const rootReducer = (state = {}, action) => {

	return {
		otherState: ((state = {}, action) => {
			if (action.type == "Another Action") {
				return {...state, test: "ok"}
			}
			return state
		})(state.otherState, action),
		requests: requestReducer(state.requests, action)
	}
}

const store = createStore(
	rootReducer,
	compose(
		applyMiddleware(
			(store) => (next) => action => {
				if (action.__request) {
					if (action.__request.initial) {
						action.__request.asd = "1"
					} else {
						console.log("RE________", action)
					}
				}

				return next(action)
			},
			clientMiddleware(socket)
		)
	)
)

store.subscribe(() => {
	console.log("\nSTATE\n")

	console.log(store.getState())
})

const resolveActionCreator = requestAction("action.RESOLVE", type => ({
	type: "RESOLVE"
}))

const rejectActionCreator = requestAction("action.REJECT", type => ({
	type: "REJECT"
}))

const actions = bindAndTrace({
	resolveActionCreator,
	rejectActionCreator
}, store.dispatch)

setTimeout(() => {
	actions.resolveActionCreator().then(res => console.log("RES", res))
}, 1000)

setTimeout(() => {
	actions.rejectActionCreator().catch(error => console.log("ERR", error))
}, 2000)